package TrainObjectHandling
{

    function blowHorn(%obj)
    {
	%obj.hornApplied = 1;
	%obj.playAudio(2, hornBegin);
	toggleBellOn(%obj);
	%obj.sch = %obj.schedule(85,"playAudio", 2, hornMiddle);
    }

    function stopHorn(%obj)
    {
	cancel(%obj.sch);
	%obj.hornApplied = 0;
	%obj.playAudio(2, hornEnd);
    }


    function toggleBellOn(%obj)
    {
	%obj.bellIsOn = 1;
	%obj.playAudio(3, bell);
    }

    function toggleBellOff(%obj)
    {
	%obj.bellIsOn = 0;
	%obj.stopAudio(3);
    }

    function serverCmdreverseTrain(%client)
    {
	%mount = %client.getcontrolobject().getObjectMount();
	%DataBlockName = Train.getId();

	if(isObject(%mount))
	{
	    if(%mount.getDataBlock() == %DataBlockName)
	    {
		if(isObject(%client) && !%client.player.getMountedImage(0))
		{

		    if(%mount.getControllingClient() != %client)
			return;

		    reverseVehicle(%mount);
		}
	    }
      
	    Parent::serverCmdreverseTrain(%client);
	    //Parent for other train vehicles
	}
    }

    function fxDTSBrick::spawnVehicle(%brick)
    {
	%client = findclientbybl_id(%brick.stackBL_ID);
	%TrainDBID = Train.getId();

	if(!$TrainVehicle_AdminOnly || %client.isAdmin || %brick.vehicleDataBlock != %TrainDBID)
	    parent::spawnVehicle(%brick);

	else
	    commandToClient(%client, 'centerPrint', "Spawning this vehicle is currently <color:FFFFFF>admin only.", 3);
    }


    function armor::onTrigger(%this, %obj, %triggerNum, %triggerVal)
    {

	//%mount	obj of our vehicle
	//%obj		obj of our player
	//%obj.client	client of the player

	%DataBlockName = Train.getId();
	%mount = %obj.getObjectMount();

	if(isObject(%mount))
	{
	    if(%mount.getDataBlock() == %DataBlockName && %triggerNum == 0 && !%mount.getControllingClient().canLeaveTrain)
	    {
		%client = %obj.client;
		if(isObject(%client) && !%client.player.getMountedImage(0))
		{

		    //Former bug: anyone in vehicle could hit horn
		    if(%mount.getControllingClient() != %obj.client)
			return;

		    if(getSimTime() - %mount.lastHornEndBlow < 430)
			return;

		    if(%triggerVal == 1)
		    {
			%mount.lastHornStartBlow = getSimTime();
		        blowHorn(%mount);
		    }

		    else if(%triggerVal == 0)
		    {			    
		        %mount.lastHornEndBlow = getSimTime();
			stopHorn(%mount);
		    }
		    return;
		}
	    }
	}
      
	Parent::onTrigger(%this,%obj,%triggerNum, %triggerVal);
    }


    function armor::onUnMount(%this, %obj, %mountedObj, %node)
    {
	%mount = %mountedObj;
	if(%mount.hornApplied == 1)
	{
	    %mount.lastHornEndBlow = getSimTime();
	    stopHorn(%mount);
	}

    	Parent::onUnMount(%this, %obj, %mountedObj, %node);
    }


    function servercmdtogglebell(%client)
    {
	%DataBlockName = Train.getId();
	%mount = %client.getcontrolobject().getObjectMount();
	if(isObject(%mount))
	{
	    if(%mount.getDataBlock() == %DataBlockName)
	    {
		if(isObject(%client) && !%client.player.getMountedImage(0))
		{

		    if(%mount.getControllingClient() != %client)
			return;

		    if(%mount.bellIsOn == 1)
		        toggleBellOff(%mount);

		    else
			toggleBellOn(%mount);

		    return;
		}
	    }
	}
      
	Parent::servercmdtogglebell(%client);
	//We want to parent it in case the player is not on the train, and some other train vehicle exists
    }

};

activatepackage(TrainObjectHandling);