//customSounds.cs	For engine sounds and any sound not native to BL
//otherSounds.cs	Regular sounds of a vehicle
//server.cs		Vehicle settings, speedcheck
//Support_objects.cs	Things relating to modifying of the actual train(audio+horn+moving)

exec("./customSounds.cs");

if(!isObject(TrainExplosionSound))
{
   exec("./otherDB.cs");
}
//----------------------------------------------------------------------------

datablock WheeledVehicleTire(TrainTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "./shapes/traintire.dts";
	
	mass = 10;
    radius = 1;
    staticFriction = 5;
   kineticFriction = 5;
   restitution = 0.5;	

   // Spring that generates lateral tire forces
   lateralForce = 18000;
   lateralDamping = 4000;
   lateralRelaxation = 0.01;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 14000;
   longitudinalDamping = 2000;
   longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleTire(TrainBackTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "./shapes/trainbacktire.dts";
	
	mass = 10;
    radius = 1;
    staticFriction = 5;
   kineticFriction = 5;
   restitution = 0.5;	

   // Spring that generates lateral tire forces
   lateralForce = 18000;
   lateralDamping = 4000;
   lateralRelaxation = 0.01;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 14000;
   longitudinalDamping = 2000;
   longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(TrainSpring)
{
   // Wheel suspension properties
   length = 0.6;			 // Suspension travel
   force = 4000; //3000;		 // Spring force
   damping = 600; //600;		 // Spring damping
   antiSwayForce = 6; //3;		 // Lateral anti-sway force
};

datablock WheeledVehicleSpring(TrainBackSpring)
{
   // Wheel suspension properties
   length = 0.6;			 // Suspension travel
   force = 4000; //3000;		 // Spring force
   damping = 600; //600;		 // Spring damping
   antiSwayForce = 6; //3;		 // Lateral anti-sway force
};
datablock WheeledVehicleData(Train)
{
    category = "Vehicles";
    displayName = " ";
    shapeFile = "./shapes/train.dts";
    emap = true;
    minMountDist = 3;
   
    numMountPoints = 14;
    mountThread[0] = "root";
    mountThread[1] = "root";
    mountThread[2] = "root";
    mountThread[3] = "root";
    mountThread[4] = "root";
    mountThread[5] = "root";
    mountThread[6] = "root";
    mountThread[7] = "root";
    mountThread[8] = "root";
    mountThread[9] = "root";
    mountThread[10] = "root";
    mountThread[11] = "root";
    mountThread[12] = "root";
    mountThread[13] = "root";

    maxDamage = 200.00;
    destroyedLevel = 200.00;
    energyPerDamagePoint = 160;
    speedDamageScale = 1.04;
    collDamageThresholdVel = 20.0;
    collDamageMultiplier   = 0.02;

    massCenter = "0 0 0";
    //massBox = "2 5 1";

    maxSteeringAngle = 0.1;  // Maximum steering angle, should match animation
    integration = 4;           // Force integration time: TickSec/Rate
    //tireEmitter = TireEmitter; // All the tires use the same dust emitter

    // 3rd person camera settings
    cameraRoll = false;         // Roll the camera with the vehicle
    cameraMaxDist = 13;         // Far distance from vehicle
    cameraOffset = 6;        // Vertical offset from camera mount point
    cameraLag = 0.0;           // Velocity lag of camera
    cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
    cameraTilt = 0.4;
    collisionTol = 0.1;        // Collision distance tolerance
    contactTol = 0.1;

    useEyePoint = true;    

    defaultTire    = TrainTire;
    defaultSpring    = TrainSpring;
    flatTire    = TrainFlatTire;
    flatSpring    = TrainFlatSpring;

    numWheels = 8;

    // Rigid Body
    mass = 300;
    density = 5.0;
    drag = 1.6;
    bodyFriction = 0.6;
    bodyRestitution = 0.6;
    minImpactSpeed = 10;       // Impacts over this invoke the script callback
    softImpactSpeed = 10;      // Play SoftImpact Sound
    hardImpactSpeed = 15;      // Play HardImpact Sound
    groundImpactMinSpeed    = 10.0;

    // Engine
    engineTorque = 300;      // Engine power
    engineBrake = 150;        // Braking when throttle is 0
    brakeTorque = 400;        // When brakes are applied
    maxWheelSpeed = 70;       // Engine scale by current speed / max speed

    rollForce        = 0;
    yawForce        = 0;
    pitchForce        = 1000;
    rotationalDrag        = 0.2;

    // Energy
    maxEnergy = 100;
    jetForce = 3000;
    minJetEnergy = 30;
    jetEnergyDrain = 2;

    splash = TrainSplash;
    splashVelocity = 4.0;
    splashAngle = 67.0;
    splashFreqMod = 300.0;
    splashVelEpsilon = 0.60;
    bubbleEmitTime = 1.4;
    splashEmitter[0] = TrainFoamDropletsEmitter;
    splashEmitter[1] = TrainFoamEmitter;
    splashEmitter[2] = TrainBubbleEmitter;
    mediumSplashSoundVelocity = 10.0;   
    hardSplashSoundVelocity = 20.0;   
    exitSplashSoundVelocity = 5.0;
        
    //mediumSplashSound = "";
    //hardSplashSound = "";
    //exitSplashSound = "";
    
    // Sounds
    //jetSound = ScoutThrustSound;
    //engineSound = idleSound;
    squealSound = squealSound;
    softImpactSound = slowImpactSound;
    hardImpactSound = fastImpactSound;
    //wheelImpactSound = slowImpactSound;

    //explosion = VehicleExplosion;
    justcollided = 0;

    uiName = "Train";
    rideable = true;
    lookUpLimit = 0.65;
    lookDownLimit = 0.45;

    paintable = true;
   
    damageEmitter[0] = TrainBurnEmitter;
    damageEmitterOffset[0] = "0.0 0.0 0.0 ";
    damageLevelTolerance[0] = 0.99;

    damageEmitter[1] = TrainBurnEmitter;
    damageEmitterOffset[1] = "0.0 0.0 0.0 ";
    damageLevelTolerance[1] = 1.0;

    numDmgEmitterAreas = 1;

    initialExplosionProjectile = TrainExplosionProjectile;
    initialExplosionOffset = 0;         //offset only uses a z value for now

    burnTime = 4000;

    finalExplosionProjectile = TrainFinalExplosionProjectile;
    finalExplosionOffset = 0.5;          //offset only uses a z value for now


    minRunOverSpeed    = 0.1;   //how fast you need to be going to run someone over (do damage)
    runOverDamageScale = 20;     //when you run over someone, speed * runoverdamagescale = damage amt
    runOverPushScale   = 20;   //how hard a person you're running over gets pushed
};

function TrainSpeedCheck(%this, %obj)
{


	if(!isObject(%obj))
		return;

	%vehicle = %obj;


	%slot = 0; //Play the sound in the driver's spot
	%speed = vectorLen(%obj.getVelocity());
	if(!%vehicle.oldSpeed)
	    %vehicle.oldSpeed = %speed;

	//Braking is not working currently
	if(%vehicle.oldSpeed)
	{
		if((%vehicle.oldSpeed - %speed) > 2) //Braking rate of speed in 500MS
			%applyBrakes = true;

		if(%speed < 1)
			%applyBrakes = false;
	}

	if(%speed < 0) //Keeps throwing random negative numbers when train is at dead stop
	    %speed = 0;

	%vehicle.oldSpeed = %speed;
	commandtoclient(%vehicle.getControllingClient(),'bottomprint', mFloor(%speed * 2) @"<color:FFFF00>BPS", 1);




	//We use else if's so that it will find a true statement then skip the rest
	if(%speed < 2) {
	    %vehicle.stopAudio(%slot);
	    %vehicle.stopThread(0);
	    }

	else if(%speed < 3) {
	    %vehicle.playThread(0,"cruise1");
	    }

	else if(%speed < 10)
	    %vehicle.playAudio(%slot, throttle0Sound);

	else if(%speed < 15)
	    %vehicle.playAudio(%slot, throttle1Sound);

	else if(%speed < 30)
	    %vehicle.playAudio(%slot, throttle2Sound);

	else if(%speed < 31)
	    %vehicle.playAudio(%slot, throttle3Sound);

	else if(%speed < 40) {
	    %vehicle.stopThread(0);
	    %vehicle.playThread(0,"cruise2");
	    }

	else if(%speed < 60)
	    %vehicle.playAudio(%slot, throttle4Sound);

	else if(%speed < 80)
	    %vehicle.playAudio(%slot, throttle5Sound);

	else if(%speed < 100)
	    %vehicle.playAudio(%slot, throttle6Sound);



	if(%applyBrakes)
		%vehicle.playAudio(1, squealSound);
	if(!%applyBrakes)
		%vehicle.stopAudio(1);
	    

	schedule(500,0,"TrainSpeedCheck",%this,%obj);
}

datablock ParticleData(TrainExhaustParticle)
{
   textureName          = "base/data/particles/cloud";
   dragCoefficient      = 0.0;
   windCoefficient      = 0.5;
   gravityCoefficient   = -0.5; 
   inheritedVelFactor   = 0.2;
   lifetimeMS           = 300;
   lifetimeVarianceMS   = 0;
   useInvAlpha = true;
   spinRandomMin = 0.0;
   spinRandomMax = 0.0;

   colors[0]     = "0.7 0.5 0.2 0.7";
   colors[1]     = "0.7 0.7 0.7 0.3";
   colors[1]     = "0.9 0.9 0.9 0.";

   sizes[0]      = 0.9;
   sizes[1]      = 1.5;

   times[0]      = 0;
   times[1]      = 0.1;
};

datablock ParticleEmitterData(TrainExhaustEmitter)
{
   ejectionPeriodMS = 100;
   periodVarianceMS = 10;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.2;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TrainExhaustParticle";
};

datablock ShapeBaseImageData(TrainExhaustImage1)
{
   shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 15;
   rotation = "1 0 0 -90";

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateEmitter[1]					= TrainExhaustEmitter;
	stateEmitterTime[1]				= 10000;

};

function TrainSmokeCheck(%obj)
{
  %obj.mountImage(TrainExhaustImage1,2);
}

function Train::onadd(%this, %obj)
{

	parent::onadd(%this,%obj);
	//Switched to first position so the vehicle is created before it's checked on
	%obj.setWheelSteering(0,0);
	%obj.setWheelSteering(1,0);
	%obj.setWheelSteering(2,0);
	%obj.setWheelSteering(3,0);
	%obj.setWheelSteering(4,0);
	%obj.setWheelSteering(5,0);
	%obj.setWheelSteering(6,0);
	%obj.setWheelSteering(7,0);

	%obj.setWheelPowered(4,false);
	%obj.setWheelPowered(5,false);
	%obj.setWheelPowered(6,false);
	%obj.setWheelPowered(7,false);

	%obj.setWheelTire(4,"TrainBackTire");
	%obj.setWheelTire(5,"TrainBackTire");
	%obj.setWheelTire(6,"TrainBackTire");
	%obj.setWheelTire(7,"TrainBackTire");

	%obj.setWheelSpring(4,"TrainBackSpring");
	%obj.setWheelSpring(5,"TrainBackSpring");
	%obj.setWheelSpring(6,"TrainBackSpring");
	%obj.setWheelSpring(7,"TrainBackSpring");

	TrainSpeedCheck(%this, %obj);

	TrainSmokeCheck(%obj);  

	//Traintire.radius=0.65;	// Messes others players
	//Trainbacktire.radius=0.55;	// up so they are glitchy
}


exec("./Support_objects.cs");
